"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _stream = require("stream");
var _bingImageSearchAsyncIterator = _interopRequireDefault(require("bing-image-search-async-iterator"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function asyncGeneratorStep(n, t, e, r, o, a, c) { try { var i = n[a](c), u = i.value; } catch (n) { return void e(n); } i.done ? t(u) : Promise.resolve(u).then(r, o); }
function _asyncToGenerator(n) { return function () { var t = this, e = arguments; return new Promise(function (r, o) { var a = n.apply(t, e); function _next(n) { asyncGeneratorStep(a, r, o, _next, _throw, "next", n); } function _throw(n) { asyncGeneratorStep(a, r, o, _next, _throw, "throw", n); } _next(void 0); }); }; }
class BingImageSearchStream extends _stream.Readable {
  constructor(options) {
    super({
      objectMode: true,
      highWaterMark: 1
    });
    this.iterator = (0, _bingImageSearchAsyncIterator.default)(options);
    if (this.iterator == null) {
      throw new Error('failed to create iterator');
    } else if (this.iterator.next !== 'function') {
      throw new Error('iterator is missing next();');
    }
    this.done = false;
  }
  _read() {
    var _this = this;
    return _asyncToGenerator(function* () {
      try {
        const result = yield _this.iterator.next();
        _this.done = result.done;
        _this.push(!_this.done ? result.value : null);
      } catch (err) {
        process.nextTick(() => {
          _this.emit('error', err);
        });
      }
    })();
  }
  _destroy(err, cb) {
    var _this2 = this;
    return _asyncToGenerator(function* () {
      let error = err;
      if (!_this2.done) {
        if (typeof _this2.iterator.return === 'function') {
          try {
            yield _this2.iterator.return();
          } catch (err2) {
            error = err2;
          }
        }
      }
      cb(error);
    })();
  }
}
exports.default = BingImageSearchStream;
module.exports = exports.default;